<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2008 Tim Lochmueller
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

class tx_flrealurlimage_fehook {    

	/*
	 * Hook method for realurl image decode
	 *
	 * @param	
	 * @param	 	 
	 * @return 	nothing
	 */
	function checkImageDecode (&$params,&$ref) {
    	$this->pagePathtoID(); 	  
	}
    
	/*
	* Outputting the image that fits to the realurl request
	*		
	* @param		nothing
	* @return		nothing
	*/
	function pagePathtoID() {
	    // Path of the requested image
		$path = str_replace(t3lib_div::getIndpEnv('TYPO3_SITE_URL'),"",t3lib_div::getIndpEnv('TYPO3_REQUEST_URL'));
        
		// look up in DB-table if there is a image stored for this realurl
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('image_path,tstamp','tx_flrealurlimage_cache','realurl_path=\''.$path.'\'', '', '', 1);
		if($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0){
			
			// get the information to the requested image
			$data = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
			$info = getimagesize(PATH_site.$data['image_path']);
			
			// cacheControl is switched on and the image has not been modified since last request
			// => loaded from browser cache 
			if ($GLOBALS['fl_realurl_image']['cacheControl'] && $_SERVER['HTTP_IF_MODIFIED_SINCE']) {
				$lastGet = strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE']);
				if ($data['tstamp'] != 0 && $lastGet <= $data['tstamp']){
					header("HTTP/1.1 304 Not Modified");
					die();
				}
			}
			
			// send headers for image
			header('Content-Type: '.$info['mime']);
			header('Content-Length: '.filesize(PATH_site.$data['image_path']));			
			if($GLOBALS['fl_realurl_image']['cacheControl'] && $data['tstamp'] != 0) {
				header('Last-Modified: '.gmdate('D, d M Y H:i:s', $data['tstamp']) . ' GMT');           
			}
			
			// output the image istelf
			readfile(PATH_site.$data['image_path']);
			
			// finisch
			die();
		}
	}
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fl_realurl_image/class.tx_flrealurlimage_fehook.php']){
   include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fl_realurl_image/class.tx_flrealurlimage_fehook.php']);
} // if
?>